//========================================================================
//
//      w_powf.c
//
//      Part of the standard mathematical function library
//
//========================================================================
//####COPYRIGHTBEGIN####
//                                                                          
// -------------------------------------------                              
// The contents of this file are subject to the Red Hat eCos Public License 
// Version 1.1 (the "License"); you may not use this file except in         
// compliance with the License.  You may obtain a copy of the License at    
// http://www.redhat.com/                                                   
//                                                                          
// Software distributed under the License is distributed on an "AS IS"      
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
// License for the specific language governing rights and limitations under 
// the License.                                                             
//                                                                          
// The Original Code is eCos - Embedded Configurable Operating System,      
// released September 30, 1998.                                             
//                                                                          
// The Initial Developer of the Original Code is Red Hat.                   
// Portions created by Red Hat are                                          
// Copyright (C) 1998, 1999, 2000 Red Hat, Inc.                             
// All Rights Reserved.                                                     
// -------------------------------------------                              
//                                                                          
//####COPYRIGHTEND####
//========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):     luoqi
// Contributors:  luoqi
// Date:          2001-09-20
// Purpose:     
// Description: 
// Usage:       
//
//####DESCRIPTIONEND####
//
//========================================================================

// CONFIGURATION

#include <pkgconf/libm.h>   // Configuration header

// Include the Math library?
#ifdef CYGPKG_LIBM     

// Derived from code with the following copyright



/* @(#)w_pow.c 1.3 95/01/18 */
/*
 * ====================================================
 * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.
 *
 * Developed at SunSoft, a Sun Microsystems, Inc. business.
 * Permission to use, copy, modify, and distribute this
 * software is freely granted, provided that this notice 
 * is preserved.
 * ====================================================
 */

/* 
 * wrapper powf(x,y) return x**y
 */

#include "mathincl/fdlibm.h"


        float powf(float x, float y)	/* wrapper powf */
{
#ifdef CYGSEM_LIBM_COMPAT_IEEE_ONLY
        return  __ieee754_powf(x,y);
#else
        float z;
        z=__ieee754_powf(x,y);
        if(cyg_libm_get_compat_mode() == CYGNUM_LIBM_COMPAT_IEEE||isnanf(y)) return z;
        if(isnanf(x)) {
            if(y==(float)0.0) 
		/* powf(NaN,0.0) */
                return (float)__kernel_standard((double)x,(double)y,142);
            else 
                return z;
        }
        if(x==(float)0.0){ 
            if(y==(float)0.0)
		/* powf(0.0,0.0) */
                return (float)__kernel_standard((double)x,(double)y,120);
            if(finitef(y)&&y<(float)0.0)
		/* powf(0.0,negative) */
                return (float)__kernel_standard((double)x,(double)y,123);
            return z;
        }
        if(!finitef(z)) {
            if(finitef(x)&&finitef(y)) {
                if(isnanf(z))
		    /* powf neg**non-int */
                    return (float)__kernel_standard((double)x,(double)y,124);
                else 
		    /* powf overflow */
                    return (float)__kernel_standard((double)x,(double)y,121);
            }
        } 
        if(z==(float)0.0&&finitef(x)&&finitef(y))
	    /* powf underflow */
            return (float)__kernel_standard((double)x,(double)y,122);
        return z;
#endif
}

#endif // ifdef CYGPKG_LIBM     

// EOF w_powf.c
