//===========================================================================
//
//      e_fmodf.c
//
//      Part of the standard mathematical function library
//
//===========================================================================
//####COPYRIGHTBEGIN####
//                                                                          
// -------------------------------------------                              
// The contents of this file are subject to the Red Hat eCos Public License 
// Version 1.1 (the "License"); you may not use this file except in         
// compliance with the License.  You may obtain a copy of the License at    
// http://www.redhat.com/                                                   
//                                                                          
// Software distributed under the License is distributed on an "AS IS"      
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
// License for the specific language governing rights and limitations under 
// the License.                                                             
//                                                                          
// The Original Code is eCos - Embedded Configurable Operating System,      
// released September 30, 1998.                                             
//                                                                          
// The Initial Developer of the Original Code is Red Hat.                   
// Portions created by Red Hat are                                          
// Copyright (C) 1998, 1999, 2000 Red Hat, Inc.                             
// All Rights Reserved.                                                     
// -------------------------------------------                              
//                                                                          
//####COPYRIGHTEND####
//===========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):   luoqi
// Contributors:  luoqi
// Date:        2001-09-20
// Purpose:     
// Description: 
// Usage:       
//
//####DESCRIPTIONEND####
//
//===========================================================================

// CONFIGURATION

#include <pkgconf/libm.h>   // Configuration header

// Include the Math library?
#ifdef CYGPKG_LIBM     

// Derived from code with the following copyright


/* @(#)e_fmod.c 1.3 95/01/18 */
/*
 * ====================================================
 * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.
 *
 * Developed at SunSoft, a Sun Microsystems, Inc. business.
 * Permission to use, copy, modify, and distribute this
 * software is freely granted, provided that this notice 
 * is preserved.
 * ====================================================
 */

/* 
 * __ieee754_fmod(x,y)
 * Return x mod y in exact arithmetic
 * Method: shift and subtract
 */

#include "mathincl/fdlibm.h"

static const float one = 1.0, Zero[] = {0.0, -0.0,};

        float __ieee754_fmodf(float x, float y)
{
        int n,hx,hy,hz,ix,iy,sx,i;

        hx = CYG_LIBM_FL(x);            /* high word of x */
        hy = CYG_LIBM_FL(y);            /* high word of y */
        sx = hx&0x80000000;             /* sign of x */
        hx ^=sx;                /* |x| */
        hy &= 0x7fffffff;       /* |y| */

    /* purge off exception values */
        if(hy==0||(hx>=0x7f800000)||		/* y=0,or x not finite */
          (hy>0x7f800000))			/* or y is NaN */
            return (x*y)/(x*y);
        if(hx<hy) return x;			/* |x|<|y| return x */
	if(hx==hy) 
            return Zero[(unsigned)sx>>31];	/* |x|=|y| return x*0*/

    /* determine ix = ilogb(x) */
        if(hx<0x00800000) {     /* subnormal x */
	    for (ix = -126,i=(hx<<8); i>0; i<<=1) ix -=1;
        } else ix = (hx>>23)-127;

    /* determine iy = ilogb(y) */
        if(hy<0x00800000) {     /* subnormal y */
	    for (iy = -126,i=(hy<<8); i>0; i<<=1) iy -=1;
        } else iy = (hy>>23)-127;

    /* set up hx, hy and align y to x */
        if(ix >= -126) 
            hx = 0x00800000|(0x007fffff&hx);
        else {          /* subnormal x, shift x to normal */
            n = -126-ix;
	    hx = hx<<n;
        }
        if(iy >= -126) 
            hy = 0x00800000|(0x007fffff&hy);
        else {          /* subnormal y, shift y to normal */
            n = -126-iy;
	    hy = hy<<n;
        }

    /* fix point fmod */
        n = ix - iy;
        while(n--) {
            hz=hx-hy;
            if(hz<0){hx = hx+hx;}
            else {
                if(hz==0)		/* return sign(x)*0 */
                    return Zero[(unsigned)sx>>31];
                hx = hz+hz;
            }
        }
        hz=hx-hy;
        if(hz>=0) {hx=hz;}

    /* convert back to floating value and restore the sign */
        if(hx==0)			/* return sign(x)*0 */
            return Zero[(unsigned)sx>>31];      
        while(hx<0x00800000) {		/* normalize x */
            hx = hx+hx;
            iy -= 1;
        }
        if(iy>= -1022) {		/* normalize output */
            hx = ((hx-0x00800000)|((iy+127)<<23));
            CYG_LIBM_FL(x) = hx|sx;
        } else {			/* subnormal output */
            n = -126 - iy;
	    hx >>= n;
            CYG_LIBM_FL(x) = hx|sx;
            x *= one;           /* create necessary signal */
        }
        return x;               /* exact output */
}

#endif // ifdef CYGPKG_LIBM     

// EOF e_fmodf.c
