//========================================================================
//
//      e_powf.c
//
//      Part of the standard mathematical function library
//
//========================================================================
//####COPYRIGHTBEGIN####
//                                                                          
// -------------------------------------------                              
// The contents of this file are subject to the Red Hat eCos Public License 
// Version 1.1 (the "License"); you may not use this file except in         
// compliance with the License.  You may obtain a copy of the License at    
// http://www.redhat.com/                                                   
//                                                                          
// Software distributed under the License is distributed on an "AS IS"      
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
// License for the specific language governing rights and limitations under 
// the License.                                                             
//                                                                          
// The Original Code is eCos - Embedded Configurable Operating System,      
// released September 30, 1998.                                             
//                                                                          
// The Initial Developer of the Original Code is Red Hat.                   
// Portions created by Red Hat are                                          
// Copyright (C) 1998, 1999, 2000 Red Hat, Inc.                             
// All Rights Reserved.                                                     
// -------------------------------------------                              
//                                                                          
//####COPYRIGHTEND####
//========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):     luoqi
// Contributors:  luoqi
// Date:          2001-09-20
// Purpose:     
// Description: 
// Usage:       
//
//####DESCRIPTIONEND####
//
//========================================================================

// CONFIGURATION

#include <pkgconf/libm.h>   // Configuration header

// Include the Math library?
#ifdef CYGPKG_LIBM     

// Derived from code with the following copyright


/* @(#)e_pow.c 1.3 95/01/18 */
/*
 * ====================================================
 * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.
 *
 * Developed at SunSoft, a Sun Microsystems, Inc. business.
 * Permission to use, copy, modify, and distribute this
 * software is freely granted, provided that this notice 
 * is preserved.
 * ====================================================
 */

/* __ieee754_pow(x,y) return x**y
 *
 *                    n
 * Method:  Let x =  2   * (1+f)
 *     1. Compute and return log2(x) in two pieces:
 *             log2(x) = w1 + w2,
 *        where w1 has 53-24 = 29 bit trailing zeros.
 *     2. Perform y*log2(x) = n+y' by simulating muti-precision 
 *        arithmetic, where |y'|<=0.5.
 *     3. Return x**y = 2**n*exp(y'*log2)
 *
 * Special cases:
 *     1.  (anything) ** 0  is 1
 *     2.  (anything) ** 1  is itself
 *     3.  (anything) ** NAN is NAN
 *     4.  NAN ** (anything except 0) is NAN
 *     5.  +-(|x| > 1) **  +INF is +INF
 *     6.  +-(|x| > 1) **  -INF is +0
 *     7.  +-(|x| < 1) **  +INF is +0
 *     8.  +-(|x| < 1) **  -INF is +INF
 *     9.  +-1         ** +-INF is NAN
 *     10. +0 ** (+anything except 0, NAN)               is +0
 *     11. -0 ** (+anything except 0, NAN, odd integer)  is +0
 *     12. +0 ** (-anything except 0, NAN)               is +INF
 *     13. -0 ** (-anything except 0, NAN, odd integer)  is +INF
 *     14. -0 ** (odd integer) = -( +0 ** (odd integer) )
 *     15. +INF ** (+anything except 0,NAN) is +INF
 *     16. +INF ** (-anything except 0,NAN) is +0
 *     17. -INF ** (anything)  = -0 ** (-anything)
 *     18. (-anything) ** (integer) is (-1)**(integer)*(+anything**integer)
 *     19. (-anything except 0 and inf) ** (non-integer) is NAN
 *
 * Accuracy:
 *     pow(x,y) returns x**y nearly rounded. In particular
 *                     pow(integer,integer)
 *     always returns the correct integer provided it is 
 *     representable.
 *
 * Constants :
 * The hexadecimal values are the intended ones for the following 
 * constants. The decimal values may be used, provided that the 
 * compiler will convert from decimal to binary accurately enough 
 * to produce the hexadecimal values shown.
 */

#include "mathincl/fdlibm.h"

static const float 
bp[] = {1.0, 1.5,},
dp_h[] = { 0.0, 5.84960938e-01,}, /* 0x3f15c000 */
dp_l[] = { 0.0, 1.56322085e-06,}, /* 0x35d1cfdc */
zero    =  0.0,
one     =  1.0,
two     =  2.0,
two24   =  16777216.0,  /* 0x4b800000 */
huge    =  1.0e30,
tiny    =  1.0e-30,
	/* poly coefs for (3/2)*(log(x)-2s-2/3*s**3 */
L1  =  6.0000002384e-01, /* 0x3f19999a */
L2  =  4.2857143283e-01, /* 0x3edb6db7 */
L3  =  3.3333334327e-01, /* 0x3eaaaaab */
L4  =  2.7272811532e-01, /* 0x3e8ba305 */
L5  =  2.3066075146e-01, /* 0x3e6c3255 */
L6  =  2.0697501302e-01, /* 0x3e53f142 */
P1   =  1.6666667163e-01, /* 0x3e2aaaab */
P2   = -2.7777778450e-03, /* 0xbb360b61 */
P3   =  6.6137559770e-05, /* 0x388ab355 */
P4   = -1.6533901999e-06, /* 0xb5ddea0e */
P5   =  4.1381369442e-08, /* 0x3331bb4c */
lg2  =  6.9314718246e-01, /* 0x3f317218 */
lg2_h  =  6.93145752e-01, /* 0x3f317200 */
lg2_l  =  1.42860654e-06, /* 0x35bfbe8c */
ovt =  4.2995665694e-08, /* -(128-log2(ovfl+.5ulp)) */
cp    =  9.6179670095e-01, /* 0x3f76384f =2/(3ln2) */
cp_h  =  9.6179199219e-01, /* 0x3f763800 =head of cp */
cp_l  =  4.7017383622e-06, /* 0x369dc3a0 =tail of cp_h */
ivln2    =  1.4426950216e+00, /* 0x3fb8aa3b =1/ln2 */
ivln2_h  =  1.4426879883e+00, /* 0x3fb8aa00 =16b 1/ln2*/
ivln2_l  =  7.0526075433e-06; /* 0x36eca570 =1/ln2 tail*/

        float __ieee754_powf(float x, float y)
{
        float z,ax,z_h,z_l,p_h,p_l;
        float y1,t1,t2,r,s,t,u,v,w;
        int i,j,k,yisint,n;
        int hx,hy,ix,iy;

        hx = CYG_LIBM_FL(x);
        hy = CYG_LIBM_FL(y);
        ix = hx&0x7fffffff;  iy = hy&0x7fffffff;

    /* y==zero: x**0 = 1 */
        if(iy==0) return one;      

    /* +-NaN return x+y */
        if(ix > 0x7f800000 ||
           iy > 0x7f800000)
                return x+y;     

    /* determine if y is an odd int when x < 0
     * yisint = 0       ... y is not an integer
     * yisint = 1       ... y is an odd int
     * yisint = 2       ... y is an even int
     */
        yisint  = 0;
        if(hx<0) {      
            if(iy>=0x4b800000) yisint = 2;	/* even integer y */
            else if(iy>=0x3f800000) {
                k = (iy>>23)-0x7f;		/* exponent */
		j = iy>>(23-k);
		if((j<<(23-k))==iy) yisint = 2-(j&1);
            }           
        } 

    /* special value of y */
	if (iy==0x7f800000) {       /* y is +-inf */
	    if(ix==0x3f800000)
		return  y - y;      /* inf**+-1 is NaN */
	    else if (ix > 0x3f800000)/* (|x|>1)**+-inf = inf,0 */
		return (hy>=0)? y: zero;
	    else                    /* (|x|<1)**-,+inf = inf,0 */
		return (hy<0)?-y: zero;
	} 
	if(iy==0x3f800000) {        /* y is  +-1 */
	    if(hy<0) return one/x; else return x;
	}
	if(hy==0x40000000) return x*x; /* y is  2 */
	if(hy==0x3f000000) {        /* y is  0.5 */
	    if(hx>=0)       /* x >= +0 */
	    return __ieee754_sqrtf(x); 
	}

        ax   = fabsf(x);
    /* special value of x */
	if(ix==0x7f800000||ix==0||ix==0x3f800000){
	    z = ax;                 /*x is +-0,+-inf,+-1*/
	    if(hy<0) z = one/z;     /* z = (1/|x|) */
	    if(hx<0) {
		if(((ix-0x3f800000)|yisint)==0) {
		    z = (z-z)/(z-z); /* (-1)**non-int is NaN */
		} else if(yisint==1) 
		    z = -z;         /* (x<0)**odd = -(|x|**odd) */
	    }
	    return z;
        }
    
    /* (x<0)**(non-int) is NaN */
        if(((((unsigned)hx>>31)-1)|yisint)==0)
            return (x-x)/(x-x);

    /* |y| is huge */
        if(iy>0x4d000000) { /* if |y| > 2**27 */
        /* over/underflow if x is not close to one */
	    if(ix<0x3f7ffff8) return (hy<0)? huge*huge:tiny*tiny;
	    if(ix>0x3f800007) return (hy>0)? huge*huge:tiny*tiny;
        /* now |1-x| is tiny <= 2**-20, suffice to compute 
           log(x) by x-x^2/2+x^3/3-x^4/4 */
            t = x-1;            /* t has 20 trailing zeros */
            w = (t*t)*((float)0.5-t*((float)0.333333333333-t*(float)0.25));
            u = ivln2_h*t;      /* ivln2_h has 16 sig. bits */
            v = t*ivln2_l-w*ivln2;
            t1 = u+v;
            CYG_LIBM_FL(t1) &= 0xfffff000;
            t2 = v-(t1-u);
        } else {
            float s2,s_h,s_l,t_h,t_l;
            n = 0;
        /* take care subnormal number */
            if(ix<0x00800000)
                {ax *= two24; n -= 24; ix = CYG_LIBM_FL(ax); }
            n  += ((ix)>>23)-0x7f;
            j  = ix&0x007fffff;
        /* determine interval */
            ix = j|0x3f800000;          /* normalize ix */
            if(j<=0x1cc471) k=0;        /* |x|<sqrt(3/2) */
            else if(j<0x5db3d7) k=1;    /* |x|<sqrt(3)   */
            else {k=0;n+=1;ix -= 0x00800000;}
            CYG_LIBM_FL(ax) = ix;

        /* compute s = s_h+s_l = (x-1)/(x+1) or (x-1.5)/(x+1.5) */
            u = ax-bp[k];               /* bp[0]=1.0, bp[1]=1.5 */
            v = one/(ax+bp[k]);
            s = u*v;
            s_h = s;
            CYG_LIBM_FL(s_h) &= 0xfffff000;
        /* t_h=ax+bp[k] High */
            t_h = zero;
            CYG_LIBM_FL(t_h)=((ix>>1)|0x20000000)+0x00400000+(k<<21); 
            t_l = ax - (t_h-bp[k]);
            s_l = v*((u-s_h*t_h)-s_h*t_l);
        /* compute log(ax) */
            s2 = s*s;
            r = s2*s2*(L1+s2*(L2+s2*(L3+s2*(L4+s2*(L5+s2*L6)))));
            r += s_l*(s_h+s);
            s2  = s_h*s_h;
            t_h = (float)3.0+s2+r;
            CYG_LIBM_FL(t_h) &= 0xfffff000;
            t_l = r-((t_h-(float)3.0)-s2);
        /* u+v = s*(1+...) */
            u = s_h*t_h;
            v = s_l*t_h+t_l*s;
        /* 2/(3log2)*(s+...) */
            p_h = u+v;
            CYG_LIBM_FL(p_h) &= 0xfffff000;
            p_l = v-(p_h-u);
            z_h = cp_h*p_h;             /* cp_h+cp_l = 2/(3*log2) */
            z_l = cp_l*p_h+p_l*cp+dp_l[k];
        /* log2(ax) = (s+..)*2/(3*log2) = n + dp_h + z_h + z_l */
            t = (float)n;
            t1 = (((z_h+z_l)+dp_h[k])+t);
            CYG_LIBM_FL(t1) &= 0xfffff000;
            t2 = z_l-(((t1-t)-dp_h[k])-z_h);
        }

        s = one; /* s (sign of result -ve**odd) = -1 else = 1 */
        if(((((unsigned)hx>>31)+1)|(yisint-1))==0)
	    s = -one;/* (-ve)**(odd int) */

    /* split up y into y1+y2 and compute (y1+y2)*(t1+t2) */
        y1  = y;
        CYG_LIBM_FL(y1) &= 0xfffff000;
        p_l = (y-y1)*t1+y*t2;
        p_h = y1*t1;
        z = p_l+p_h;
        j = CYG_LIBM_FL(z);
        if (j>0x43000000)				/* z > 128 */
	    return s*huge*huge;				/* overflow */
        if (j==0x43000000) {				/* z == 128 */
	    if(p_l+ovt>z-p_h) return s*huge*huge;	/* overflow */
	}
        else if((j&0x7fffffff)>0x43160000)		/* z < -150 */
	    return s*tiny*tiny;				/* underflow */
	else if(j==0xc3160000) {			/* z == -150 */
	    if(p_l<=z-p_h) return s*tiny*tiny;		/* underflow */
        }
    /*
     * compute 2**(p_h+p_l)
     */
        i = j&0x7fffffff;
        k = (i>>23)-0x7f;
        n = 0;
        if(i>0x3f000000) {              /* if |z| > 0.5, set n = [z+0.5] */
            n = j+(0x00800000>>(k+1));
            k = ((n&0x7fffffff)>>23)-0x7f;     /* new k for n */
            t = zero;
            CYG_LIBM_FL(t) = (n&~(0x007fffff>>k));
            n = ((n&0x007fffff)|0x00800000)>>(23-k);
            if(j<0) n = -n;
            p_h -= t;
        } 
        t = p_l+p_h;
        CYG_LIBM_FL(t) &= 0xfffff000;
        u = t*lg2_h;
        v = (p_l-(t-p_h))*lg2+t*lg2_l;
        z = u+v;
        w = v-(z-u);
        t  = z*z;
        t1  = z - t*(P1+t*(P2+t*(P3+t*(P4+t*P5))));
        r  = (z*t1)/(t1-two)-(w+z*w);
        z  = one-(r-z);
        j  = CYG_LIBM_FL(z);
        j += (n<<23);
        if((j>>23)<=0) z = scalbnf(z,n); /* subnormal output */
        else CYG_LIBM_FL(z) += (n<<23);
        return s*z;
}

#endif // ifdef CYGPKG_LIBM     

// EOF e_powf.c
