//===========================================================================
//
//      s_modff.c
//
//      Part of the standard mathematical function library
//
//===========================================================================
//####COPYRIGHTBEGIN####
//                                                                          
// -------------------------------------------                              
// The contents of this file are subject to the Red Hat eCos Public License 
// Version 1.1 (the "License"); you may not use this file except in         
// compliance with the License.  You may obtain a copy of the License at    
// http://www.redhat.com/                                                   
//                                                                          
// Software distributed under the License is distributed on an "AS IS"      
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
// License for the specific language governing rights and limitations under 
// the License.                                                             
//                                                                          
// The Original Code is eCos - Embedded Configurable Operating System,      
// released September 30, 1998.                                             
//                                                                          
// The Initial Developer of the Original Code is Red Hat.                   
// Portions created by Red Hat are                                          
// Copyright (C) 1998, 1999, 2000 Red Hat, Inc.                             
// All Rights Reserved.                                                     
// -------------------------------------------                              
//                                                                          
//####COPYRIGHTEND####
//===========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):   luoqi
// Contributors:  luoqi
// Date:        2001-09-20
// Purpose:     
// Description: 
// Usage:       
//
//####DESCRIPTIONEND####
//
//===========================================================================

// CONFIGURATION

#include <pkgconf/libm.h>   // Configuration header

// Include the Math library?
#ifdef CYGPKG_LIBM     

// Derived from code with the following copyright


/* @(#)s_modf.c 1.3 95/01/18 */
/*
 * ====================================================
 * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.
 *
 * Developed at SunSoft, a Sun Microsystems, Inc. business.
 * Permission to use, copy, modify, and distribute this
 * software is freely granted, provided that this notice 
 * is preserved.
 * ====================================================
 */

/*
 * modff(float x, float *iptr) 
 * return fraction part of x, and return x's integral part in *iptr.
 * Method:
 *      Bit twiddling.
 *
 * Exception:
 *      No exception.
 */

#include "mathincl/fdlibm.h"

static const float one = 1.0;

        float modff(float x, float *iptr)
{
        int i0,j0;
        unsigned i;
        i0 =  CYG_LIBM_FL(x);
        j0 = ((i0>>23)&0xff)-0x7f;	/* exponent of x */
        if(j0<23) {			/* integer part in high x */
            if(j0<0) {			/* |x|<1 */
                CYG_LIBM_FLp(iptr) = i0&0x80000000; /* *iptr = +-0 */
                return x;
            } else {
                i = (0x007fffff)>>j0;
                if((i0&i)==0) {		/* x is integral */
                    *iptr = x;
                    CYG_LIBM_FL(x) &= 0x80000000; /* return +-0 */
                    return x;
                } else {
                    CYG_LIBM_FLp(iptr) = i0&(~i);
                    return x - *iptr;
                }
            }
        } else {			/* no fraction part */
            *iptr = x*one;
            CYG_LIBM_FL(x) &= 0x80000000; /* return +-0 */
            return x;
        }
}

#endif // ifdef CYGPKG_LIBM     

// EOF s_modff.c
