//===========================================================================
//
//      s_rintf.c
//
//      Part of the standard mathematical function library
//
//===========================================================================
//####COPYRIGHTBEGIN####
//                                                                          
// -------------------------------------------                              
// The contents of this file are subject to the Red Hat eCos Public License 
// Version 1.1 (the "License"); you may not use this file except in         
// compliance with the License.  You may obtain a copy of the License at    
// http://www.redhat.com/                                                   
//                                                                          
// Software distributed under the License is distributed on an "AS IS"      
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
// License for the specific language governing rights and limitations under 
// the License.                                                             
//                                                                          
// The Original Code is eCos - Embedded Configurable Operating System,      
// released September 30, 1998.                                             
//                                                                          
// The Initial Developer of the Original Code is Red Hat.                   
// Portions created by Red Hat are                                          
// Copyright (C) 1998, 1999, 2000 Red Hat, Inc.                             
// All Rights Reserved.                                                     
// -------------------------------------------                              
//                                                                          
//####COPYRIGHTEND####
//===========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):   luoqi
// Contributors:  luoqi
// Date:        2001-09-20
// Purpose:     
// Description: 
// Usage:       
//
//####DESCRIPTIONEND####
//
//===========================================================================

// CONFIGURATION

#include <pkgconf/libm.h>   // Configuration header

// Include the Math library?
#ifdef CYGPKG_LIBM     

// Derived from code with the following copyright


/* @(#)s_rint.c 1.3 95/01/18 */
/*
 * ====================================================
 * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.
 *
 * Developed at SunSoft, a Sun Microsystems, Inc. business.
 * Permission to use, copy, modify, and distribute this
 * software is freely granted, provided that this notice 
 * is preserved.
 * ====================================================
 */

/*
 * rintf(x)
 * Return x rounded to integral value according to the prevailing
 * rounding mode.
 * Method:
 *      Using floating addition.
 * Exception:
 *      Inexact flag raised if x not equal to rintf(x).
 */

#include "mathincl/fdlibm.h"

static const double
TWO23[2]={
  8.3886080000e+06, /* 0x4b000000 */
  -8.3886080000e+06, /* 0xcb000000 */
};

        float rintf(float x)
{
        int i0,j0,sx;
        unsigned i,i1;
        float w,t;
        i0 =  CYG_LIBM_FL(x);
        sx = (i0>>31)&1;
        j0 = ((i0>>23)&0xff)-0x7f;
        if(j0<23) {
            if(j0<0) {  
                if((i0&0x7fffffff)==0) return x;
                i1 |= (i0&0x07fffff);
                i0 &= 0xfff00000;
                i0 |= ((i1|-i1)>>9)&0x400000;
                CYG_LIBM_FL(x)=i0;
                w = TWO23[sx]+x;
                t =  w-TWO23[sx];
                i0 = CYG_LIBM_FL(t);
                CYG_LIBM_FL(t) = (i0&0x7fffffff)|(sx<<31);
                return t;
            } else {
                i = (0x007fffff)>>j0;
                if((i0&i)==0) return x; /* x is integral */
                i>>=1;
                if((i0&i)!=0) i0 = (i0&(~i))|((0x100000)>>j0);
            }
        } else {
            if(j0==0x80) return x+x;	/* inf or NaN */
            else return x;              /* x is integral */
        }
        CYG_LIBM_FL(x) = i0;
        w = TWO23[sx]+x;
        return w-TWO23[sx];
}

#endif // ifdef CYGPKG_LIBM     

// EOF s_rintf.c
