//===========================================================================
//
//      s_scalbnf.c
//
//      Part of the standard mathematical function library
//
//===========================================================================
//####COPYRIGHTBEGIN####
//                                                                          
// -------------------------------------------                              
// The contents of this file are subject to the Red Hat eCos Public License 
// Version 1.1 (the "License"); you may not use this file except in         
// compliance with the License.  You may obtain a copy of the License at    
// http://www.redhat.com/                                                   
//                                                                          
// Software distributed under the License is distributed on an "AS IS"      
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
// License for the specific language governing rights and limitations under 
// the License.                                                             
//                                                                          
// The Original Code is eCos - Embedded Configurable Operating System,      
// released September 30, 1998.                                             
//                                                                          
// The Initial Developer of the Original Code is Red Hat.                   
// Portions created by Red Hat are                                          
// Copyright (C) 1998, 1999, 2000 Red Hat, Inc.                             
// All Rights Reserved.                                                     
// -------------------------------------------                              
//                                                                          
//####COPYRIGHTEND####
//===========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):   luoqi
// Contributors:  luoqi
// Date:        2001-09-20
// Purpose:     
// Description: 
// Usage:       
//
//####DESCRIPTIONEND####
//
//===========================================================================

// CONFIGURATION

#include <pkgconf/libm.h>   // Configuration header

// Include the Math library?
#ifdef CYGPKG_LIBM     

// Derived from code with the following copyright


/* @(#)s_scalbn.c 1.3 95/01/18 */
/*
 * ====================================================
 * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.
 *
 * Developed at SunSoft, a Sun Microsystems, Inc. business.
 * Permission to use, copy, modify, and distribute this
 * software is freely granted, provided that this notice 
 * is preserved.
 * ====================================================
 */

/* 
 * scalbnf (float x, int n)
 * scalbnf(x,n) returns x* 2**n  computed by  exponent  
 * manipulation rather than by actually performing an 
 * exponentiation or a multiplication.
 */

#include "mathincl/fdlibm.h"

static const float
two25   =  3.355443200e+07,     /* 0x4c000000 */
twom25  =  2.9802322388e-08,    /* 0x33000000 */
huge   = 1.0e+30,
tiny   = 1.0e-30;

        float scalbnf (float x, int n)
{
        int  k,hx;
        hx = CYG_LIBM_FL(x);
        k = (hx&0x7f800000)>>23;                /* extract exponent */
        if (k==0) {                             /* 0 or subnormal x */
            if ((hx&0x7fffffff)==0) return x; /* +-0 */
            x *= two25; 
            hx = CYG_LIBM_FL(x);
            k = ((hx&0x7f800000)>>23) - 25; 
            if (n< -50000) return tiny*x;       /*underflow*/
	}
        if (k==0xff) return x+x;               /* NaN or Inf */
        k = k+n; 
        if (k >  0xfe) return huge*copysignf(huge,x); /* overflow  */
        if (k > 0)                              /* normal result */
            {CYG_LIBM_FL(x) = (hx&0x807fffff)|(k<<23); return x;}
        if (k <= -25) {
            if (n > 50000)      /* in case integer overflow in n+k */
                return huge*copysignf(huge,x);   /*overflow*/
            else return tiny*copysignf(tiny,x);  /*underflow*/
        }
        k += 25;                                /* subnormal result */
        CYG_LIBM_FL(x) = (hx&0x807fffff)|(k<<23);
        return x*twom25;
}

#endif // ifdef CYGPKG_LIBM     

// EOF s_scalbnf.c
